stages:
  - build
  - deploy

image: python:3.12
cache:
  key: shared
  paths:
    - .cache
variables:
  PIP_CACHE_DIR: $CI_PROJECT_DIR/.cache/pip
  SPHINX_IMMATERIAL_EXTERNAL_RESOURCE_CACHE_DIR: $CI_PROJECT_DIR/.cache/sphinx_immaterial/external_resources
.before-apt: &before-apt
  - mkdir -p .config .cache/apt
  - export APT_CONFIG="$CI_PROJECT_DIR/.config/apt.conf"
  - echo Dir::Cache \"$CI_PROJECT_DIR/.cache/apt\"; >> $APT_CONFIG
  - echo Dir::State \"$CI_PROJECT_DIR/.cache/apt\"; >> $APT_CONFIG

validate-voevents:
  stage: build
  script:
    - *before-apt
    - apt-get update
    - apt-get -y install --no-install-recommends libxml2-utils curl
    - curl -O https://www.ivoa.net/xml/VOEvent/VOEvent-v2.0.xsd
    - echo 99ba1e3b8351a6f792a2499d3acc70695898ae82588165b6599712a85df1a795  VOEvent-v2.0.xsd > hash
    - sha256sum --check hash
    - xmllint --schema VOEvent-v2.0.xsd _static/*.xml

.sphinx: &sphinx
  stage: build
  variables:
    SPHINXOPTS: -W
  script:
    - pip install -r requirements.txt
    - sphinx-build -M $CI_JOB_NAME . .

html:
  <<: *sphinx
  artifacts:
    expose_as: html
    expire_in: 2 weeks  # P&P circulation period
    paths:
      - html/index.html
      - html
  environment:
    name: review/$CI_COMMIT_REF_SLUG
    url: $CI_JOB_URL/artifacts/file/html/index.html
    on_stop: stop review
    auto_stop_in: 2 weeks

stop review:
  stage: build
  when: manual
  environment:
    action: stop
    name: review/$CI_COMMIT_REF_SLUG
  script: ["true"]  # no-op

doctest:
  <<: *sphinx

latexpdf:
  <<: *sphinx
  before_script:
    - *before-apt
    - apt-get update
    - apt-get -y install --no-install-recommends latexmk texlive-latex-recommended texlive-fonts-recommended tex-gyre texlive-latex-extra
  artifacts:
    expose_as: pdf
    expire_in: 2 weeks  # P&P circulation period
    paths:
      - latex/LIGOVirgoKAGRAPublicAlertsUserGuide.pdf

linkcheck:
  <<: *sphinx
  allow_failure: true

spelling:
  <<: *sphinx
  before_script:
    - *before-apt
    - apt-get update
    - apt-get -y install enchant-2
    - pip install sphinxcontrib-spelling
  script:
    - pip install -r requirements.txt
    - sphinx-build -M $CI_JOB_NAME . .
    # Fail and show output if there were spelling errors.
    - .gitlab/spelling_codeclimate.py
  artifacts:
    when: always
    reports:
      codequality: spelling.codeclimate.json

pages:
  stage: deploy
  script:
    - mv html public/
    - mv latex/LIGOVirgoKAGRAPublicAlertsUserGuide.pdf public/
  artifacts:
    paths:
      - public
    expire_in: 100 years
  # Only run for stable version tags (e.g. v1.2.3)
  only:
    - /^v\d+(\.\d+)*$/
  except:
    - branches
  dependencies:
    - html
    - latexpdf

avro:
  stage: build
  script:
    - pip install -r requirements.txt
    # Fail if avro schema not valid
    - .gitlab/avro_schema_validator.py

validate-jsonschema:
  stage: build
  script:
    - pip install -r requirements.txt
    # Fail if JSON Schema is not valid or if any of the sample JSON alerts are
    # not valid
    - .gitlab/json_schema_validator.py _static/MS181101ab-*json

validate-kafka-notices:
  stage: build
  script:
    - pip install -r requirements.txt
    # Fail if avro packets fail validation against schema or if deserialized avro and json packets are not equal
    - .gitlab/kafka_notices_validator.py

validate-json-display:
  stage: build
  script:
    - pip install -r requirements.txt
    # Fail if avro packets fail validation against schema or if deserialized avro and json packets are not equal
    - .gitlab/json_display_notices_validator.py
